#include <stdio.h>
#include <math.h>
void preamble();
void postamble();

void
main () {
	int minute;
	int radius = 100;			// 300mm radius of the outer edge of the clock
	int minuteLength = 10;		// 10mm length for the minute tick marks
	int fiveminuteLength = 20;	// 20mm length for the 5 minute tick marks
	int length;					// The length of the current tick mark
	
	float degreeperminute = 360/60;
	double angle;
	float xOuter, yOuter, xInner, yInner;	// The coordinates of the tick mark
	
	float extractAmount = 1.2;
	float retractAmount = 10;
	float printSpeed = 1000;
	float z = 0.2;
	
	preamble();
	
	for(int l=0;l<24;l++) {								// A 24-hour clock
		// Count for one hour
		for(minute=0;minute<60;minute++) {
			angle = 90 - (degreeperminute * minute);	// Add 90 to start at Noon and go clockwise
			angle = angle * M_PI / 180.0;				// Convert to radians
			
			// Set the length of the tick mark
			length = minuteLength;
			if(minute%5 == 0) length = fiveminuteLength;
			
			// Calculate the endpoints of the tick mark
			xOuter = cos(angle) * radius;
			yOuter = sin(angle) * radius;
			xInner = cos(angle) * (radius-length);
			yInner = sin(angle) * (radius-length);
			
			printf("G0 X%f Y%f Z%f F6000\n",xInner, yInner, z);
			
			printf("G0 E%f F8000\n", retractAmount);
			printf("G1 X%f Y%f E%f F%f\n",xOuter, yOuter, extractAmount, printSpeed);
			printf("G0 E%f F8000\n", -retractAmount);
			
			printf("G0 Z%f F6000\n", z+40);
			printf("G4 S60\n");	// Pause 1 minute
		}
		z += 0.3;
	}
	
	postamble();
}

void preamble() {
	printf("G90\n");
	printf("M83 ; Extruder absolute\n");
	printf("M106 S0\n");
	printf("M140 S60\n");
	printf("M190 S60\n");
	printf("M104 S210 T0\n");
	printf("M109 S210 T0\n");
	printf("G28 ; home all axes\n");
	printf("T0\n");
	printf("G92 E0.0000\n");
	printf("G0 X0 Y0 Z0.1 f3000\n");
}

void postamble() {
	printf("M106 S0 ; turn off cooling fan\n");
	printf("M104 S0 ; turn off extruder\n");
	printf("M140 S0 ; turn off bed\n");
	printf("G28 ; home axes\n");
	printf("M84 ; disable motors\n");
}